/*
 * Copyright 2013 Netflix, Inc.
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package com.netflix.governator.lifecycle;

import com.google.common.collect.ImmutableSet;
import com.google.inject.Inject;
import java.util.Collection;
import java.util.Set;

public class LifecycleManagerArguments
{
    @Inject(optional = true)
    private LifecycleConfigurationProviders configurationProvider = new LifecycleConfigurationProviders();

    @Inject(optional = true)
    private Set<LifecycleListener>          lifecycleListeners = ImmutableSet.of();

    @Inject
    public LifecycleManagerArguments()
    {
    }

    public LifecycleConfigurationProviders getConfigurationProvider()
    {
        return configurationProvider;
    }

    public Collection<LifecycleListener> getLifecycleListeners()
    {
        return lifecycleListeners;
    }

    public void setConfigurationProvider(LifecycleConfigurationProviders configurationProvider)
    {
        this.configurationProvider = configurationProvider;
    }

    public void setLifecycleListeners(Collection<LifecycleListener> lifecycleListeners)
    {
        this.lifecycleListeners = ImmutableSet.copyOf(lifecycleListeners);
    }
}
